#[=============================[.rst:
FindNTFS3g
----------

finds nsfs-3g. who woulda guessed.

Result Variables
^^^^^^^^^^^^^^^^

Defines the following variables:

``NTFS3g_FOUND``
  True if the system has ntfs-3g
``NTFS3g_Mkfs_EXECUTABLE``
  Path to mkfs.ntfs
``NTFS3g_Mount_EXECUTABLE``
  Path to ntfs-3g

#]=============================]

include(FindPackageHandleStandardArgs)

# mkfs.ntfs
find_program(NTFS3g_Mkfs_EXECUTABLE NAMES mkfs.ntfs)

# ntfs-3g
find_program(NTFS3g_Mount_EXECUTABLE NAMES ntfs-3g)

find_package_handle_standard_args(NTFS3g
	FOUND_VAR NTFS3g_FOUND
	REQUIRED_VARS
		NTFS3g_Mkfs_EXECUTABLE
		NTFS3g_Mount_EXECUTABLE
)
