#include "./syscall.hxx"
#include "./logging.hxx"
#include "./bugcheck.hxx"

/**
 * We don't have libc as we're running below the rest of the userspace, we can't use the dynamic linker to load it as we run outside of the SystemRoot chroot.
 * If we need something, we will need to implement it ourselves.
 */
extern "C" void _start() {
	ExecutiveLog("Lindows OS Executive started");

	ExecutiveLog("Loading bugcheck kernel");
	InitializeBugCheckHandler();

	LnxExitProcess(42);
}
