#pragma once

#include <lcrash/types.h>
#include <lcrash/driver/sysbus.h>

/**
 * Initialize the VGA driver
 */
void VgaInitialize();

/**
 * Vga drivers are ready
 */
bool VgaIsInitialized();

/**
 * Create a legacy VGA device, due to how VGA works, only one may exist at a time :D
 */
struct SysbusDevice* VgaCreateDevice(struct SysbusDevice* Parent);

/**
 * Delete a legacy VGA device
 */
void VgaDeleteDevice(struct SysbusDevice* Device);
