OUTPUT_FORMAT(elf64-x86-64)

ENTRY(entry64)

SECTIONS {
	. = 0;

	.dynsym : { *(.dynsym); }

	.rela.dyn : {
		*(.rela.text);
		*(.rela.rodata);
		*(.rela.data .rela.data.*);
		*(.rela.bss);
	}

	.text : {
		_text = .;
		*(.text);
		_etext = .;
	}

	.rodata : {
		_rodata = .;
		*(.rodata);
		_erodata = .;
	}

	.data : {
		_data = .;
		*(.data .data.*);
		_edata = .;
	}

	.bss : {
		_bss = .;
		*(.bss);
		_ebss = .;
	}

	.debug_info 0 : { *(.debug_info); }
	.debug_abbrev 0 : { *(.debug_abbrev); }
	.debug_aranges 0 : { *(.debug_aranges); }
	.debug_rnglists 0 : { *(.debug_rnglists); }
	.debug_line 0 : { *(.debug_line); }
	.debug_str 0 : { *(.debug_str); }
	.debug_line_str 0 : { *(.debug_line_str); }
	.debug_gdb_scripts 0 : { *(.debug_gdb_scripts); }
	
	/DISCARD/ : {
		*(*);
	}
}
